Index: uspace/lib/tbarcfg/test/tbarcfg.c
===================================================================
--- uspace/lib/tbarcfg/test/tbarcfg.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/tbarcfg/test/tbarcfg.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,592 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <pcut/pcut.h>
+#include <tbarcfg/tbarcfg.h>
+#include <stdbool.h>
+#include <stdio.h>
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(tbarcfg);
+
+typedef struct {
+	bool notified;
+} tbarcfg_test_resp_t;
+
+static void test_cb(void *);
+
+/** Creating, opening and closing taskbar configuration */
+PCUT_TEST(create_open_close)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	/* Create new repository */
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tbarcfg_close(tbcfg);
+
+	/* Re-open the repository */
+
+	rc = tbarcfg_open(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Iterating over start menu entries */
+PCUT_TEST(first_next)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e1 = NULL, *e2 = NULL;
+	smenu_entry_t *e;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a", false, &e1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(e1);
+
+	rc = smenu_entry_create(tbcfg, "B", "b", false, &e2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(e2);
+
+	/* Create entry without getting a pointer to it */
+	rc = smenu_entry_create(tbcfg, "C", "c", false, NULL);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	e = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_EQUALS(e1, e);
+	e = tbarcfg_smenu_next(e);
+	PCUT_ASSERT_EQUALS(e2, e);
+	e = tbarcfg_smenu_next(e);
+	PCUT_ASSERT_NOT_NULL(e);
+	e = tbarcfg_smenu_next(e);
+	PCUT_ASSERT_NULL(e);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Iterating over start menu entries backwards */
+PCUT_TEST(last_prev)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e1 = NULL, *e2 = NULL;
+	smenu_entry_t *e;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a", false, &e1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(e1);
+
+	rc = smenu_entry_create(tbcfg, "B", "b", false, &e2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(e2);
+
+	e = tbarcfg_smenu_last(tbcfg);
+	PCUT_ASSERT_EQUALS(e2, e);
+	e = tbarcfg_smenu_prev(e);
+	PCUT_ASSERT_EQUALS(e1, e);
+	e = tbarcfg_smenu_prev(e);
+	PCUT_ASSERT_NULL(e);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Separator entry */
+PCUT_TEST(separator)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	const char *caption;
+	const char *cmd;
+	smenu_entry_t *e1 = NULL, *e2 = NULL;
+	smenu_entry_t *e;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a", false, &e1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(e1);
+
+	rc = smenu_entry_sep_create(tbcfg, &e2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(e2);
+
+	PCUT_ASSERT_FALSE(smenu_entry_get_separator(e1));
+	PCUT_ASSERT_TRUE(smenu_entry_get_separator(e2));
+
+	tbarcfg_close(tbcfg);
+
+	/* Re-open repository */
+
+	rc = tbarcfg_open(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	e = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_NOT_NULL(e);
+
+	/* Check that new values of properties have persisted */
+	PCUT_ASSERT_FALSE(smenu_entry_get_separator(e));
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("A", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("a", cmd);
+
+	e = tbarcfg_smenu_next(e);
+
+	/* Check that entry is still a separator */
+	PCUT_ASSERT_TRUE(smenu_entry_get_separator(e));
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Getting menu entry properties */
+PCUT_TEST(get_caption_cmd_term)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e;
+	const char *caption;
+	const char *cmd;
+	bool terminal;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a", false, &e);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("A", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("a", cmd);
+	terminal = smenu_entry_get_terminal(e);
+	PCUT_ASSERT_FALSE(terminal);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Setting menu entry properties */
+PCUT_TEST(set_caption_cmd_term)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e;
+	const char *caption;
+	const char *cmd;
+	bool terminal;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a", false, &e);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("A", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("a", cmd);
+	terminal = smenu_entry_get_terminal(e);
+	PCUT_ASSERT_FALSE(terminal);
+
+	/* Set properties */
+	rc = smenu_entry_set_caption(e, "B");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	rc = smenu_entry_set_cmd(e, "b");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	smenu_entry_set_terminal(e, true);
+
+	rc = smenu_entry_save(e);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Check that properties have been set */
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("B", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("b", cmd);
+	terminal = smenu_entry_get_terminal(e);
+	PCUT_ASSERT_TRUE(terminal);
+
+	tbarcfg_close(tbcfg);
+
+	/* Re-open repository */
+
+	rc = tbarcfg_open(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	e = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_NOT_NULL(e);
+
+	/* Check that new values of properties have persisted */
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("B", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("b", cmd);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Create start menu entry */
+PCUT_TEST(entry_create)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e;
+	const char *caption;
+	const char *cmd;
+	bool terminal;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a", false, &e);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(e);
+
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("A", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("a", cmd);
+	terminal = smenu_entry_get_terminal(e);
+	PCUT_ASSERT_FALSE(terminal);
+
+	smenu_entry_destroy(e);
+
+	rc = smenu_entry_create(tbcfg, "B", "b", true, &e);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(e);
+
+	caption = smenu_entry_get_caption(e);
+	PCUT_ASSERT_STR_EQUALS("B", caption);
+	cmd = smenu_entry_get_cmd(e);
+	PCUT_ASSERT_STR_EQUALS("b", cmd);
+	terminal = smenu_entry_get_terminal(e);
+	PCUT_ASSERT_TRUE(terminal);
+
+	smenu_entry_destroy(e);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Destroy start menu entry */
+PCUT_TEST(entry_destroy)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e, *f;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a", false, &e);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	f = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_EQUALS(e, f);
+
+	rc = smenu_entry_destroy(e);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	f = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_NULL(f);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Move start menu entry up */
+PCUT_TEST(entry_move_up)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e1, *e2, *e3;
+	smenu_entry_t *f;
+	const char *caption;
+	const char *cmd;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a", false, &e1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "B", "b", false, &e2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "C", "c", false, &e3);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	f = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_EQUALS(e1, f);
+
+	/* Moving the first entry up should have no effect */
+
+	rc = smenu_entry_move_up(e1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	f = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_EQUALS(e1, f);
+
+	/* Moving the second entry up should move it to first position */
+
+	rc = smenu_entry_move_up(e2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	f = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_EQUALS(e2, f);
+
+	/* Moving the last entry up should move it to second position */
+
+	rc = smenu_entry_move_up(e3);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	f = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_EQUALS(e2, f);
+
+	f = tbarcfg_smenu_next(f);
+	PCUT_ASSERT_EQUALS(e3, f);
+
+	f = tbarcfg_smenu_next(f);
+	PCUT_ASSERT_EQUALS(e1, f);
+
+	tbarcfg_close(tbcfg);
+
+	/* Re-open repository */
+
+	rc = tbarcfg_open(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Check that new order of entries persisted */
+
+	f = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_NOT_NULL(f);
+
+	caption = smenu_entry_get_caption(f);
+	PCUT_ASSERT_STR_EQUALS("B", caption);
+	cmd = smenu_entry_get_cmd(f);
+	PCUT_ASSERT_STR_EQUALS("b", cmd);
+
+	f = tbarcfg_smenu_next(f);
+	PCUT_ASSERT_NOT_NULL(f);
+
+	caption = smenu_entry_get_caption(f);
+	PCUT_ASSERT_STR_EQUALS("C", caption);
+	cmd = smenu_entry_get_cmd(f);
+	PCUT_ASSERT_STR_EQUALS("c", cmd);
+
+	f = tbarcfg_smenu_next(f);
+	PCUT_ASSERT_NOT_NULL(f);
+
+	caption = smenu_entry_get_caption(f);
+	PCUT_ASSERT_STR_EQUALS("A", caption);
+	cmd = smenu_entry_get_cmd(f);
+	PCUT_ASSERT_STR_EQUALS("a", cmd);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Move start menu entry down */
+PCUT_TEST(entry_move_down)
+{
+	errno_t rc;
+	tbarcfg_t *tbcfg;
+	char fname[L_tmpnam], *p;
+	smenu_entry_t *e1, *e2, *e3;
+	smenu_entry_t *f;
+	const char *caption;
+	const char *cmd;
+
+	p = tmpnam(fname);
+	PCUT_ASSERT_NOT_NULL(p);
+
+	rc = tbarcfg_create(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "A", "a", false, &e1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "B", "b", false, &e2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = smenu_entry_create(tbcfg, "C", "c", false, &e3);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	f = tbarcfg_smenu_last(tbcfg);
+	PCUT_ASSERT_EQUALS(e3, f);
+
+	/* Moving the last entry down should have no effect */
+
+	rc = smenu_entry_move_down(e3);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	f = tbarcfg_smenu_last(tbcfg);
+	PCUT_ASSERT_EQUALS(e3, f);
+
+	/* Moving the second entry down should move it to last position */
+
+	rc = smenu_entry_move_down(e2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	f = tbarcfg_smenu_last(tbcfg);
+	PCUT_ASSERT_EQUALS(e2, f);
+
+	/* Moving the first entry down should move it to second position */
+
+	rc = smenu_entry_move_down(e1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	f = tbarcfg_smenu_last(tbcfg);
+	PCUT_ASSERT_EQUALS(e2, f);
+
+	f = tbarcfg_smenu_prev(f);
+	PCUT_ASSERT_EQUALS(e1, f);
+
+	f = tbarcfg_smenu_prev(f);
+	PCUT_ASSERT_EQUALS(e3, f);
+
+	tbarcfg_close(tbcfg);
+
+	/* Re-open repository */
+
+	rc = tbarcfg_open(fname, &tbcfg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Check that new order of entries persisted */
+
+	f = tbarcfg_smenu_first(tbcfg);
+	PCUT_ASSERT_NOT_NULL(f);
+
+	caption = smenu_entry_get_caption(f);
+	PCUT_ASSERT_STR_EQUALS("C", caption);
+	cmd = smenu_entry_get_cmd(f);
+	PCUT_ASSERT_STR_EQUALS("c", cmd);
+
+	f = tbarcfg_smenu_next(f);
+	PCUT_ASSERT_NOT_NULL(f);
+
+	caption = smenu_entry_get_caption(f);
+	PCUT_ASSERT_STR_EQUALS("A", caption);
+	cmd = smenu_entry_get_cmd(f);
+	PCUT_ASSERT_STR_EQUALS("a", cmd);
+
+	f = tbarcfg_smenu_next(f);
+	PCUT_ASSERT_NOT_NULL(f);
+
+	caption = smenu_entry_get_caption(f);
+	PCUT_ASSERT_STR_EQUALS("B", caption);
+	cmd = smenu_entry_get_cmd(f);
+	PCUT_ASSERT_STR_EQUALS("b", cmd);
+
+	tbarcfg_close(tbcfg);
+	remove(fname);
+}
+
+/** Notifications can be delivered from tbarcfg_notify() to a listener. */
+PCUT_TEST(notify)
+{
+	errno_t rc;
+	tbarcfg_listener_t *lst;
+	tbarcfg_test_resp_t test_resp;
+
+	test_resp.notified = false;
+
+	printf("create listener resp=%p\n", (void *)&test_resp);
+	rc = tbarcfg_listener_create(TBARCFG_NOTIFY_DEFAULT,
+	    test_cb, &test_resp, &lst);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = tbarcfg_notify(TBARCFG_NOTIFY_DEFAULT);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(test_resp.notified);
+	tbarcfg_listener_destroy(lst);
+}
+
+static void test_cb(void *arg)
+{
+	tbarcfg_test_resp_t *resp = (tbarcfg_test_resp_t *)arg;
+
+	printf("test_cb: executing resp=%p\n", (void *)resp);
+	resp->notified = true;
+}
+
+PCUT_EXPORT(tbarcfg);
Index: uspace/lib/ui/include/types/ui/clickmatic.h
===================================================================
--- uspace/lib/ui/include/types/ui/clickmatic.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/types/ui/clickmatic.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Clickmatic
+ */
+
+#ifndef _UI_TYPES_CLICKMATIC_H
+#define _UI_TYPES_CLICKMATIC_H
+
+struct ui_clickmatic;
+typedef struct ui_clickmatic ui_clickmatic_t;
+
+/** Clickmatic callbacks */
+typedef struct ui_clickmatic_cb {
+	void (*clicked)(ui_clickmatic_t *, void *);
+} ui_clickmatic_cb_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/types/ui/control.h
===================================================================
--- uspace/lib/ui/include/types/ui/control.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/control.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -56,5 +56,5 @@
 	ui_evclaim_t (*pos_event)(void *, pos_event_t *);
 	/** Unfocus */
-	void (*unfocus)(void *);
+	void (*unfocus)(void *, unsigned);
 } ui_control_ops_t;
 
Index: uspace/lib/ui/include/types/ui/filelist.h
===================================================================
--- uspace/lib/ui/include/types/ui/filelist.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/types/ui/filelist.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file File list
+ */
+
+#ifndef _UI_TYPES_FILELIST_H
+#define _UI_TYPES_FILELIST_H
+
+struct ui_file_list;
+typedef struct ui_file_list ui_file_list_t;
+
+struct ui_file_list_entry;
+typedef struct ui_file_list_entry ui_file_list_entry_t;
+
+struct ui_file_list_entry_attr;
+typedef struct ui_file_list_entry_attr ui_file_list_entry_attr_t;
+
+/** File list callbacks */
+typedef struct ui_file_list_cb {
+	/** Request file list activation */
+	void (*activate_req)(ui_file_list_t *, void *);
+	/** File was selected */
+	void (*selected)(ui_file_list_t *, void *, const char *);
+} ui_file_list_cb_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/types/ui/list.h
===================================================================
--- uspace/lib/ui/include/types/ui/list.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/types/ui/list.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,72 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file List control
+ */
+
+#ifndef _UI_TYPES_LIST_H
+#define _UI_TYPES_LIST_H
+
+#include <gfx/color.h>
+
+struct ui_list;
+typedef struct ui_list ui_list_t;
+
+struct ui_list_entry;
+typedef struct ui_list_entry ui_list_entry_t;
+
+/** List entry attributes */
+typedef struct ui_list_entry_attr {
+	/** Entry caption */
+	const char *caption;
+	/** User argument */
+	void *arg;
+	/** Entry color or @c NULL to use default color */
+	gfx_color_t *color;
+	/** Entry background color or @c NULL to use default color */
+	gfx_color_t *bgcolor;
+} ui_list_entry_attr_t;
+
+/** List callbacks */
+typedef struct ui_list_cb {
+	/** Request list activation */
+	void (*activate_req)(ui_list_t *, void *);
+	/** Entry was selected */
+	void (*selected)(ui_list_entry_t *, void *);
+	/** Compare two entries (for sorting) */
+	int (*compare)(ui_list_entry_t *, ui_list_entry_t *);
+} ui_list_cb_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/types/ui/menu.h
===================================================================
--- uspace/lib/ui/include/types/ui/menu.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/menu.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,6 +37,20 @@
 #define _UI_TYPES_MENU_H
 
+#include <types/common.h>
+
 struct ui_menu;
 typedef struct ui_menu ui_menu_t;
+
+/** Menu callbacks */
+typedef struct ui_menu_cb {
+	/** Left arrow pressed */
+	void (*left)(ui_menu_t *, void *, sysarg_t);
+	/** Right arrow pressed */
+	void (*right)(ui_menu_t *, void *, sysarg_t);
+	/** Request menu closure */
+	void (*close_req)(ui_menu_t *, void *);
+	/** Accelerator key pressed */
+	void (*press_accel)(ui_menu_t *, void *, char32_t, sysarg_t);
+} ui_menu_cb_t;
 
 #endif
Index: uspace/lib/ui/include/types/ui/menubar.h
===================================================================
--- uspace/lib/ui/include/types/ui/menubar.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/menubar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,4 +40,12 @@
 typedef struct ui_menu_bar ui_menu_bar_t;
 
+/** Menu bar callbacks */
+typedef struct ui_menu_bar_cb {
+	/** Activated */
+	void (*activate)(ui_menu_bar_t *, void *);
+	/** Deactivated */
+	void (*deactivate)(ui_menu_bar_t *, void *);
+} ui_menu_bar_cb_t;
+
 #endif
 
Index: uspace/lib/ui/include/types/ui/menudd.h
===================================================================
--- uspace/lib/ui/include/types/ui/menudd.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/types/ui/menudd.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu
+ */
+
+#ifndef _UI_TYPES_MENUDD_H
+#define _UI_TYPES_MENUDD_H
+
+struct ui_menu_dd;
+typedef struct ui_menu_dd ui_menu_dd_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/types/ui/paint.h
===================================================================
--- uspace/lib/ui/include/types/ui/paint.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/paint.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,4 +36,7 @@
 #ifndef _UI_TYPES_PAINT_H
 #define _UI_TYPES_PAINT_H
+
+#include <gfx/color.h>
+#include <gfx/font.h>
 
 /** Filled circle parts */
@@ -81,4 +84,20 @@
 } ui_box_style_t;
 
+/** UI text formatting */
+typedef struct {
+	/** Text font */
+	gfx_font_t *font;
+	/** Standard color */
+	gfx_color_t *color;
+	/** Highlight color */
+	gfx_color_t *hgl_color;
+	/** Horizontal alignment */
+	gfx_halign_t halign;
+	/** Width available for the text */
+	gfx_coord_t width;
+	/** Vertical alignment */
+	gfx_valign_t valign;
+} ui_text_fmt_t;
+
 #endif
 
Index: uspace/lib/ui/include/types/ui/pbutton.h
===================================================================
--- uspace/lib/ui/include/types/ui/pbutton.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/pbutton.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,11 +37,27 @@
 #define _UI_TYPES_PBUTTON_H
 
+#include <errno.h>
+#include <gfx/coord.h>
+
 struct ui_pbutton;
 typedef struct ui_pbutton ui_pbutton_t;
+
+/** UI push button flags */
+typedef enum {
+	/** Do not depress the button in text mode */
+	ui_pbf_no_text_depress = 0x1
+} ui_pbutton_flags_t;
 
 /** Push button callbacks */
 typedef struct ui_pbutton_cb {
 	void (*clicked)(ui_pbutton_t *, void *);
+	void (*down)(ui_pbutton_t *, void *);
+	void (*up)(ui_pbutton_t *, void *);
 } ui_pbutton_cb_t;
+
+/** Push button decoration ops */
+typedef struct ui_pbutton_decor_ops {
+	errno_t (*paint)(ui_pbutton_t *, void *, gfx_coord2_t *);
+} ui_pbutton_decor_ops_t;
 
 #endif
Index: uspace/lib/ui/include/types/ui/popup.h
===================================================================
--- uspace/lib/ui/include/types/ui/popup.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/popup.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,4 +40,5 @@
 #include <io/kbd_event.h>
 #include <io/pos_event.h>
+#include <types/common.h>
 
 struct ui_popup;
@@ -50,4 +51,6 @@
 	/** Placement rectangle close to which popup should be placed */
 	gfx_rect_t place;
+	/** Input device ID associated with the popup's seat */
+	sysarg_t idev_id;
 } ui_popup_params_t;
 
Index: uspace/lib/ui/include/types/ui/scrollbar.h
===================================================================
--- uspace/lib/ui/include/types/ui/scrollbar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/types/ui/scrollbar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Scrollbar
+ */
+
+#ifndef _UI_TYPES_SCROLLBAR_H
+#define _UI_TYPES_SCROLLBAR_H
+
+#include <gfx/coord.h>
+
+struct ui_scrollbar;
+typedef struct ui_scrollbar ui_scrollbar_t;
+
+/** Scrollbar direction */
+typedef enum {
+	/** Horizontal */
+	ui_sbd_horiz,
+	/** Vertical */
+	ui_sbd_vert
+} ui_scrollbar_dir_t;
+
+/** Scrollbar callbacks */
+typedef struct ui_scrollbar_cb {
+	void (*up)(ui_scrollbar_t *, void *);
+	void (*down)(ui_scrollbar_t *, void *);
+	void (*page_up)(ui_scrollbar_t *, void *);
+	void (*page_down)(ui_scrollbar_t *, void *);
+	void (*moved)(ui_scrollbar_t *, void *, gfx_coord_t);
+} ui_scrollbar_cb_t;
+
+#endif
+
+/** @}
+ */
